@echo off
cd /d %~dp0
::begin
:BEGIN
cls
echo ========================================
echo ======Newer ISO Builder Pack v1.02======
echo ========================================
echo =====Pack by damysteryman/Team DARK=====
echo ======Powered by WIT and ApplyPPF3======
echo ========More info in README.txt=========
echo ========================================
pause

:: Version Select Menu
cls
echo ========Base ISO Version Select=========
echo 0. Autodetect!
echo 1. EUR v1
echo 2. EUR v2
echo 3. USA v1
echo 4. USA v2
echo 5. JPN v1
echo  . JPN v2 (not supported atm...)
echo =====Enter the Number corresponding=====
echo ======to your NSMBW image verison=======
SET VERINPUT=
SET /P VERINPUT=Enter Number and press Enter:

IF %VERINPUT%==0 (
	SET BASEVER=AUTO
	GOTO EXTSELECT
	)
IF %VERINPUT%==1 (
	SET BASEVER=EURv1
	SET GAMEID=SMNP01
	GOTO EXTSELECT
	)
IF %VERINPUT%==2 (
	SET BASEVER=EURv2
	SET GAMEID=SMNP01
	GOTO EXTSELECT
	)
IF %VERINPUT%==3 (
	SET BASEVER=USAv1
	SET GAMEID=SMNE01
	GOTO EXTSELECT
	)
IF %VERINPUT%==4 (
	SET BASEVER=USAv2
	SET GAMEID=SMNE01
	GOTO EXTSELECT
	)
IF %VERINPUT%==5 (
	SET BASEVER=JPNv1
	SET GAMEID=SMNJ01
	GOTO EXTSELECT
	)
::IF %VERINPUT%==6 (
::	SET BASEVER=JPNv2
::	SET GAMEID=SMNJ01
::	GOTO EXTSELECT
::	)

GOTO INPUTERROR

:EXTSELECT
cls
echo ========Newer ISO Format Select=========
echo 1. .iso
echo 2. .wbfs
echo =====Enter the Number corresponding=====
echo ========to the filetype you want========
SET EXTINPUT=
SET /P EXTINPUT=Enter Number and press Enter:

IF %EXTINPUT%==1 (
	SET FILEEXT=iso
	GOTO SAVESELECT
	)
IF %EXTINPUT%==2 (
	SET FILEEXT=wbfs
	GOTO SAVESELECT
	)

GOTO INPUTERROR

:SAVESELECT
cls
echo =========Newer Save "Slot" Select=========
echo 1. Share save "slot" with original (SMNx)
echo Original NSMBW save is unaltered, but both
echo both are in same "slot" in Data Management
echo.
echo 2. Make new save "slot" (KMNx)
echo Store save under a different custom "slot"
echo in Data Management away from original
echo ======Enter the Number corresponding======
echo ==========to the "slot" you want==========
SET SLOTINPUT=
SET /P SLOTINPUT=Enter Number and press Enter:

IF %SLOTINPUT%==1 (
	SET SLOT=SMNx-Original
	GOTO DOUBLECHECK
	)
IF %SLOTINPUT%==2 (
	SET SLOT=KMNx-Custom
	GOTO DOUBLECHECK
	)

GOTO INPUTERROR

:DOUBLECHECK
cls
echo ==========Review Settings==========
echo Selected Base Version: %BASEVER%
echo Selected Output Filetype: %FILEEXT%
echo Selected Save "Slot": %SLOT%
echo =======Is this selection ok?=======
echo 1. Yes, continue
echo 2. No, change settings
echo (Anything else). exit
echo ===================================
SET AREYOUSURE=
SET /P AREYOUSURE=Enter Number and press Enter:

IF %AREYOUSURE%==1 GOTO EXTRACT
IF %AREYOUSURE%==2 GOTO BEGIN

GOTO INPUTERROR

:INPUTERROR
echo Invalid option selected, exiting...
pause
exit

:DETECTEDVER
:Exit if supported version is not found (BASEVER not reset)
IF %BASEVER%==AUTO (
	echo Unsupported ISO version detected, exiting...
	pause
	exit
	)

echo Autodetected Base ISO Version: %BASEVER%
GOTO CONTINUE

:EXTRACT
:: Check for NewerSMBW folder before anything
IF NOT EXIST NewerSMBW\ (
	echo Cannot find the "NewerSMBW" folder containing Newer files...
	echo Please make sure you have "NewerSMBW" in the same directory
	echo as this builder pack.
	echo [NewerSMBW.zip\NewerFiles\NewerSMBW\]   This one!
	pause
	exit
	)

:: extract image
:: Autodetect
IF %BASEVER%==AUTO (
wit\wit extract -s ../ -1 -n SMN.01 . nsmb.d --psel=DATA -ovv

:Detect version and assign BASEVER
IF EXIST nsmb.d\files\COPYDATE_LAST_2009-10-03_232911 (
	SET BASEVER=EURv1
	SET GAMEID=SMNP01
	)
IF EXIST nsmb.d\files\COPYDATE_LAST_2010-01-05_152101 (
	SET BASEVER=EURv2
	SET GAMEID=SMNP01
	)
IF EXIST nsmb.d\files\COPYDATE_LAST_2009-10-03_232303 (
	SET BASEVER=USAv1
	SET GAMEID=SMNE01
	)
IF EXIST nsmb.d\files\COPYDATE_LAST_2010-01-05_143554 (
	SET BASEVER=USAv2
	SET GAMEID=SMNE01
	)
IF EXIST nsmb.d\files\COPYDATE_LAST_2009-10-03_231655 (
	SET BASEVER=JPNv1
	SET GAMEID=SMNJ01
	)
GOTO DETECTEDVER
) ELSE (
:: Not Autodetect
wit\wit extract -s ../ -1 -n %GAMEID% . nsmb.d --psel=DATA -ovv
)

:CONTINUE
:: many copy commands
copy /b NewerSMBW\Tilesets\ nsmb.d\files\Stage\Texture\
copy /b NewerSMBW\TitleReplay\ nsmb.d\files\Replay\title\
copy /b NewerSMBW\BGs\ nsmb.d\files\Object\
copy /b NewerSMBW\SpriteTex\ nsmb.d\files\Object\
copy /b NewerSMBW\Layouts\ nsmb.d\files\Layout\
mkdir nsmb.d\files\Sound\new
copy /b NewerSMBW\Music\ nsmb.d\files\Sound\new\
mkdir nsmb.d\files\Sound\new\sfx
copy /b NewerSMBW\Music\sfx\ nsmb.d\files\Sound\new\sfx\
copy /b NewerSMBW\Music\stream nsmb.d\files\Sound\stream\
copy /b NewerSMBW\Music\rsar\ nsmb.d\files\Sound\

IF %GAMEID%==SMNP01 (
copy /b NewerSMBW\Font\ nsmb.d\files\EU\EngEU\Font\
copy /b NewerSMBW\Font\ nsmb.d\files\EU\FraEU\Font\
copy /b NewerSMBW\Font\ nsmb.d\files\EU\GerEU\Font\
copy /b NewerSMBW\Font\ nsmb.d\files\EU\ItaEU\Font\
copy /b NewerSMBW\Font\ nsmb.d\files\EU\NedEU\Font\
copy /b NewerSMBW\Font\ nsmb.d\files\EU\SpaEU\Font\
copy /b NewerSMBW\Message\ nsmb.d\files\EU\EngEU\Message\
copy /b NewerSMBW\Message\ nsmb.d\files\EU\FraEU\Message\
copy /b NewerSMBW\Message\ nsmb.d\files\EU\GerEU\Message\
copy /b NewerSMBW\Message\ nsmb.d\files\EU\ItaEU\Message\
copy /b NewerSMBW\Message\ nsmb.d\files\EU\NedEU\Message\
copy /b NewerSMBW\Message\ nsmb.d\files\EU\SpaEU\Message\
copy /b NewerSMBW\OthersP\ nsmb.d\files\EU\Layout\openingTitle\
)

IF %GAMEID%==SMNE01 (
copy /b NewerSMBW\Font\ nsmb.d\files\US\EngUS\Font\
copy /b NewerSMBW\Font\ nsmb.d\files\US\FraUS\Font\
copy /b NewerSMBW\Font\ nsmb.d\files\US\SpaUS\Font\
copy /b NewerSMBW\Message\ nsmb.d\files\US\EngUS\Message\
copy /b NewerSMBW\Message\ nsmb.d\files\US\FraUS\Message\
copy /b NewerSMBW\Message\ nsmb.d\files\US\SpaUS\Message\
copy /b NewerSMBW\OthersE\ nsmb.d\files\US\Layout\openingTitle\
)

IF %GAMEID%==SMNJ01 (
copy /b NewerSMBW\Font\ nsmb.d\files\JP\Font\
copy /b NewerSMBW\Message\ nsmb.d\files\JP\Message\
copy /b NewerSMBW\OthersJ\ nsmb.d\files\JP\Layout\openingTitle\
)

mkdir nsmb.d\files\NewerRes
copy /b NewerSMBW\NewerRes\ nsmb.d\files\NewerRes\
mkdir nsmb.d\files\LevelSamples
copy /b NewerSMBW\LevelSamples\ nsmb.d\files\LevelSamples\
copy /b NewerSMBW\Others\charaChangeSelectContents.arc nsmb.d\files\Layout\charaChangeSelectContents\charaChangeSelectContents.arc
copy /b NewerSMBW\Others\characterChange.arc nsmb.d\files\Layout\characterChange\characterChange.arc
copy /b NewerSMBW\Others\continue.arc nsmb.d\files\Layout\continue\continue.arc
copy /b NewerSMBW\Others\controllerInformation.arc nsmb.d\files\Layout\controllerInformation\controllerInformation.arc
copy /b NewerSMBW\Others\corseSelectMenu.arc nsmb.d\files\Layout\corseSelectMenu\corseSelectMenu.arc
copy /b NewerSMBW\Others\corseSelectUIGuide.arc nsmb.d\files\Layout\corseSelectUIGuide\corseSelectUIGuide.arc
copy /b NewerSMBW\Others\dateFile.arc nsmb.d\files\Layout\dateFile\dateFile.arc
copy /b NewerSMBW\Others\dateFile_OLD.arc nsmb.d\files\Layout\dateFile\dateFile_OLD.arc
copy /b NewerSMBW\Others\easyPairing.arc nsmb.d\files\Layout\easyPairing\easyPairing.arc
copy /b NewerSMBW\Others\extensionControllerNunchuk.arc nsmb.d\files\Layout\extensionControllerNunchuk\extensionControllerNunchuk.arc
copy /b NewerSMBW\Others\extensionControllerYokomochi.arc nsmb.d\files\Layout\extensionControllerYokomochi\extensionControllerYokomochi.arc
copy /b NewerSMBW\Others\fileSelectBase.arc nsmb.d\files\Layout\fileSelectBase\fileSelectBase.arc
copy /b NewerSMBW\Others\fileSelectBase_OLD.arc nsmb.d\files\Layout\fileSelectBase\fileSelectBase_OLD.arc
copy /b NewerSMBW\Others\fileSelectPlayer.arc nsmb.d\files\Layout\fileSelectPlayer\fileSelectPlayer.arc
copy /b NewerSMBW\Others\gameScene.arc nsmb.d\files\Layout\gameScene\gameScene.arc
copy /b NewerSMBW\Others\infoWindow.arc nsmb.d\files\Layout\infoWindow\infoWindow.arc
copy /b NewerSMBW\Others\miniGameCannon.arc nsmb.d\files\Layout\miniGameCannon\miniGameCannon.arc
copy /b NewerSMBW\Others\miniGameWire.arc nsmb.d\files\Layout\miniGameWire\miniGameWire.arc
copy /b NewerSMBW\Others\pauseMenu.arc nsmb.d\files\Layout\pauseMenu\pauseMenu.arc
copy /b NewerSMBW\Others\pointResultDateFile.arc nsmb.d\files\Layout\pointResultDateFile\pointResultDateFile.arc
copy /b NewerSMBW\Others\pointResultDateFileFree.arc nsmb.d\files\Layout\pointResultDateFileFree\pointResultDateFileFree.arc
copy /b NewerSMBW\Others\preGame.arc nsmb.d\files\Layout\preGame\preGame.arc
copy /b NewerSMBW\Others\select_cursor.arc nsmb.d\files\Layout\select_cursor\select_cursor.arc
copy /b NewerSMBW\Others\sequenceBG.arc nsmb.d\files\Layout\sequenceBG\sequenceBG.arc
copy /b NewerSMBW\Others\staffCredit.arc nsmb.d\files\Layout\staffCredit\staffCredit.arc
copy /b NewerSMBW\Others\stockItem.arc nsmb.d\files\Layout\stockItem\stockItem.arc
copy /b NewerSMBW\Others\stockItemShadow.arc nsmb.d\files\Layout\stockItemShadow\stockItemShadow.arc
copy /b NewerSMBW\Others\yesnoWindow.arc nsmb.d\files\Layout\yesnoWindow\yesnoWindow.arc

mkdir nsmb.d\files\Maps
copy /b NewerSMBW\Maps\ nsmb.d\files\Maps\
mkdir nsmb.d\files\Maps\Texture
copy /b NewerSMBW\Maps\Texture\ nsmb.d\files\Maps\Texture\
copy /b NewerSMBW\Stages\ nsmb.d\files\Stage\
 
:: patch main.dol with .ppf
patch\ApplyPPF3 a nsmb.d\sys\main.dol patch\Newer_%BASEVER%_dolpatch.ppf

:: create new image
IF %GAMEID%==SMNP01 SET GAMEID=SMNP03
IF %GAMEID%==SMNE01 SET GAMEID=SMNE03
IF %GAMEID%==SMNJ01 SET GAMEID=SMNJ03

IF %SLOTINPUT%==1 SET SLOT=S
IF %SLOTINPUT%==2 SET SLOT=K

wit\wit copy nsmb.d ../NewerSMBW_%BASEVER%.%FILEEXT% -ovv --disc-id=%GAMEID% --ticket-id=%SLOT% --tmd-id=%SLOT% --name "Newer SMBW"

:: clean up working directory
rmdir nsmb.d /s /q

:: wait to make errors visible
pause